/* A Bison parser, made by GNU Bison 1.875.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
#define YYTOKENTYPE
/* Put the tokens into the symbol table, so that GDB and other debuggers
   know about them.  */
enum yytokentype {
	OP_LOR = 258,
	OP_LAND = 259,
	OP_GE = 260,
	OP_LE = 261,
	OP_E = 262,
	OP_SR = 263,
	OP_SL = 264,
	WAIT = 265,
	DELAY = 266,
	VAL = 267,
	STRING = 268,
	TEXT = 269
};
#endif
#define OP_LOR 258
#define OP_LAND 259
#define OP_GE 260
#define OP_LE 261
#define OP_E 262
#define OP_SR 263
#define OP_SL 264
#define WAIT 265
#define DELAY 266
#define VAL 267
#define STRING 268
#define TEXT 269




/* Copy the first part of user declarations.  */


/*
 * This file is part of the Advance project.
 *
 * Copyright (C) 2001, 2002, 2003 Andrea Mazzoleni
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * In addition, as a special exception, Andrea Mazzoleni
 * gives permission to link the code of this program with
 * the MAME library (or with modified versions of MAME that use the
 * same license as MAME), and distribute linked combinations including
 * the two.  You must obey the GNU General Public License in all
 * respects for all of the code used other than MAME.  If you modify
 * this file, you may extend this exception to your version of the
 * file, but you are not obligated to do so.  If you do not wish to
 * do so, delete this exception statement from your version.
 */

#include <stdlib.h>
#include <string.h>

#include "script.h"
#include "portable.h"

#define YYERROR_VERBOSE

int yylex(void);

void yyerror(const char* s)
{
	script_error(s);
}

static struct script_cmd* script_result;



/* Enabling traces.  */
#ifndef YYDEBUG
#define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
#undef YYERROR_VERBOSE
#define YYERROR_VERBOSE 1
#else
#define YYERROR_VERBOSE 0
#endif

#if !defined (YYSTYPE) && !defined (YYSTYPE_IS_DECLARED)

typedef union YYSTYPE {
	int val;
	const char* str;
	const char* text;
	struct script_exp* exp;
	struct script_cmd* cmd;
} YYSTYPE;
/* Line 191 of yacc.c.  */

#define yystype YYSTYPE  /* obsolescent; will be withdrawn */
#define YYSTYPE_IS_DECLARED 1
#define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */


#if !defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

#if YYSTACK_USE_ALLOCA
#define YYSTACK_ALLOC alloca
#else
#ifndef YYSTACK_USE_ALLOCA
#if defined (alloca) || defined (_ALLOCA_H)
#define YYSTACK_ALLOC alloca
#else
#ifdef __GNUC__
#define YYSTACK_ALLOC __builtin_alloca
#endif
#endif
#endif
#endif

#ifdef YYSTACK_ALLOC
/* Pacify GCC's `empty if-body' warning. */
#define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#else
#if defined (__STDC__) || defined (__cplusplus)
#include <stdlib.h>    /* INFRINGES ON USER NAME SPACE */
#define YYSIZE_T size_t
#endif
#define YYSTACK_ALLOC malloc
#define YYSTACK_FREE free
#endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (!defined (yyoverflow) \
	&& (!defined (__cplusplus) \
	|| (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc {
	short yyss;
	YYSTYPE yyvs;
};

/* The size of the maximum gap between one aligned stack and the next.  */
#define YYSTACK_GAP_MAXIMUM (sizeof(union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
#define YYSTACK_BYTES(N) \
	((N)*(sizeof(short) + sizeof(YYSTYPE))                         \
	+ YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
#ifndef YYCOPY
#if 1 < __GNUC__
#define YYCOPY(To, From, Count) \
	__builtin_memcpy(To, From, (Count) * sizeof(*(From)))
#else
#define YYCOPY(To, From, Count)              \
	do                                        \
	{                                       \
		register YYSIZE_T yyi;                \
		for (yyi = 0; yyi < (Count); yyi++)   \
			(To)[yyi] = (From)[yyi];            \
	}                                       \
	while (0)
#endif
#endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
#define YYSTACK_RELOCATE(Stack)                                        \
	do                                                                  \
	{                                                                 \
		YYSIZE_T yynewbytes;                                            \
		YYCOPY(&yyptr->Stack, Stack, yysize);                          \
		Stack = &yyptr->Stack;                                          \
		yynewbytes = yystacksize * sizeof(*Stack) + YYSTACK_GAP_MAXIMUM; \
		yyptr += yynewbytes / sizeof(*yyptr);                          \
	}                                                                 \
	while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
typedef signed char yysigned_char;
#else
typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  23
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   285

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  30
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  5
/* YYNRULES -- Number of rules. */
#define YYNRULES  33
/* YYNRULES -- Number of states. */
#define YYNSTATES  76

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   269

#define YYTRANSLATE(YYX)                                                \
	((unsigned int)(YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
	0, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 18, 2, 2, 2, 2, 5, 2,
	24, 25, 2, 15, 26, 16, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 29,
	8, 2, 9, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 7, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 27, 6, 28, 17, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
	2, 2, 2, 2, 2, 2, 1, 2, 3, 4,
	10, 11, 12, 13, 14, 19, 20, 21, 22, 23
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
	0, 0, 3, 5, 8, 10, 12, 14, 16, 20,
	24, 28, 32, 36, 40, 44, 48, 52, 56, 60,
	64, 68, 72, 76, 79, 82, 86, 91, 98, 102,
	110, 115, 121, 127
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
	31, 0, -1, 32, -1, 32, 34, -1, 34, -1,
	21, -1, 22, -1, 23, -1, 24, 33, 25, -1,
	33, 15, 33, -1, 33, 16, 33, -1, 33, 5,
	33, -1, 33, 6, 33, -1, 33, 7, 33, -1,
	33, 8, 33, -1, 33, 9, 33, -1, 33, 12,
	33, -1, 33, 11, 33, -1, 33, 10, 33, -1,
	33, 14, 33, -1, 33, 13, 33, -1, 33, 4,
	33, -1, 33, 3, 33, -1, 18, 33, -1, 17,
	33, -1, 22, 24, 25, -1, 22, 24, 33, 25,
	-1, 22, 24, 33, 26, 33, 25, -1, 27, 32,
	28, -1, 22, 24, 33, 25, 27, 32, 28, -1,
	22, 27, 32, 28, -1, 19, 24, 33, 25, 29,
	-1, 20, 24, 33, 25, 29, -1, 33, 29, -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
	0, 78, 78, 84, 89, 94, 98, 103, 108, 111,
	115, 119, 123, 127, 131, 135, 139, 143, 147, 151,
	155, 159, 163, 167, 171, 175, 180, 185, 192, 196,
	201, 206, 210, 214
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
	"$end", "error", "$undefined", "OP_LOR", "OP_LAND", "'&'", "'|'", "'^'",
	"'<'", "'>'", "OP_GE", "OP_LE", "OP_E", "OP_SR", "OP_SL", "'+'", "'-'",
	"'~'", "'!'", "WAIT", "DELAY", "VAL", "STRING", "TEXT", "'('", "')'",
	"','", "'{'", "'}'", "';'", "$accept", "script", "cmd_list", "exp",
	"cmd", 0
};
#endif

#ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
	0, 256, 257, 258, 259, 38, 124, 94, 60, 62,
	260, 261, 262, 263, 264, 43, 45, 126, 33, 265,
	266, 267, 268, 269, 40, 41, 44, 123, 125, 59
};
#endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
	0, 30, 31, 32, 32, 33, 33, 33, 33, 33,
	33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
	33, 33, 33, 33, 33, 33, 33, 33, 34, 34,
	34, 34, 34, 34
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
	0, 2, 1, 2, 1, 1, 1, 1, 3, 3,
	3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
	3, 3, 3, 2, 2, 3, 4, 6, 3, 7,
	4, 5, 5, 2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
	0, 0, 0, 0, 0, 5, 6, 7, 0, 0,
	0, 2, 0, 4, 6, 24, 23, 0, 0, 0,
	0, 0, 0, 1, 3, 0, 0, 0, 0, 0,
	0, 0, 0, 0, 0, 0, 0, 0, 0, 33,
	0, 0, 0, 25, 0, 0, 8, 28, 22, 21,
	11, 12, 13, 14, 15, 18, 17, 16, 20, 19,
	9, 10, 0, 0, 0, 26, 0, 30, 26, 31,
	32, 0, 0, 0, 27, 29
};

/* YYDEFGOTO[NTERM-NUM]. */
static const yysigned_char yydefgoto[] =
{
	-1, 10, 11, 12, 13
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -23
static const short yypact[] =
{
	244, 261, 261, -21, -18, -23, -22, -23, 261, 244,
	8, 244, 38, -23, -10, -23, -23, 261, 261, 252,
	244, 117, 208, -23, -23, 261, 261, 261, 261, 261,
	261, 261, 261, 261, 261, 261, 261, 261, 261, -23,
	252, 140, 163, -23, 69, 220, -23, -23, 207, 207,
	47, 47, 47, -3, -3, -3, -3, -3, 6, 6,
	-23, -23, 93, -6, 11, -8, 261, -23, -23, -23,
	-23, 244, 186, 232, -23, -23
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
	-23, -23, 0, -1, -7
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
	15, 16, 19, 17, 24, 20, 18, 21, 23, 22,
	35, 36, 37, 38, 40, 24, 41, 42, 44, 71,
	45, 37, 38, 69, 48, 49, 50, 51, 52, 53,
	54, 55, 56, 57, 58, 59, 60, 61, 24, 62,
	70, 25, 26, 27, 28, 29, 30, 31, 32, 33,
	34, 35, 36, 37, 38, 30, 31, 32, 33, 34,
	35, 36, 37, 38, 0, 72, 24, 39, 0, 0,
	0, 73, 25, 26, 27, 28, 29, 30, 31, 32,
	33, 34, 35, 36, 37, 38, 0, 0, 0, 0,
	0, 0, 0, 0, 65, 66, 25, 26, 27, 28,
	29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
	0, 0, 0, 0, 0, 0, 0, 0, 68, 66,
	25, 26, 27, 28, 29, 30, 31, 32, 33, 34,
	35, 36, 37, 38, 0, 0, 0, 0, 0, 0,
	0, 0, 46, 25, 26, 27, 28, 29, 30, 31,
	32, 33, 34, 35, 36, 37, 38, 0, 0, 0,
	0, 0, 0, 0, 0, 63, 25, 26, 27, 28,
	29, 30, 31, 32, 33, 34, 35, 36, 37, 38,
	0, 0, 0, 0, 0, 0, 0, 0, 64, 25,
	26, 27, 28, 29, 30, 31, 32, 33, 34, 35,
	36, 37, 38, 0, 0, 0, 0, 0, 0, 0,
	0, 74, 27, 28, 29, 30, 31, 32, 33, 34,
	35, 36, 37, 38, 0, 1, 2, 3, 4, 5,
	6, 7, 8, 0, 0, 9, 47, 1, 2, 3,
	4, 5, 6, 7, 8, 0, 0, 9, 67, 1,
	2, 3, 4, 5, 6, 7, 8, 0, 0, 9,
	75, 1, 2, 3, 4, 5, 6, 7, 8, 1,
	2, 9, 0, 5, 14, 7, 8, 43, 1, 2,
	0, 0, 5, 14, 7, 8
};

static const yysigned_char yycheck[] =
{
	1, 2, 24, 24, 11, 27, 24, 8, 0, 9,
	13, 14, 15, 16, 24, 22, 17, 18, 19, 27,
	20, 15, 16, 29, 25, 26, 27, 28, 29, 30,
	31, 32, 33, 34, 35, 36, 37, 38, 45, 40,
	29, 3, 4, 5, 6, 7, 8, 9, 10, 11,
	12, 13, 14, 15, 16, 8, 9, 10, 11, 12,
	13, 14, 15, 16, -1, 66, 73, 29, -1, -1,
	-1, 71, 3, 4, 5, 6, 7, 8, 9, 10,
	11, 12, 13, 14, 15, 16, -1, -1, -1, -1,
	-1, -1, -1, -1, 25, 26, 3, 4, 5, 6,
	7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
	-1, -1, -1, -1, -1, -1, -1, -1, 25, 26,
	3, 4, 5, 6, 7, 8, 9, 10, 11, 12,
	13, 14, 15, 16, -1, -1, -1, -1, -1, -1,
	-1, -1, 25, 3, 4, 5, 6, 7, 8, 9,
	10, 11, 12, 13, 14, 15, 16, -1, -1, -1,
	-1, -1, -1, -1, -1, 25, 3, 4, 5, 6,
	7, 8, 9, 10, 11, 12, 13, 14, 15, 16,
	-1, -1, -1, -1, -1, -1, -1, -1, 25, 3,
	4, 5, 6, 7, 8, 9, 10, 11, 12, 13,
	14, 15, 16, -1, -1, -1, -1, -1, -1, -1,
	-1, 25, 5, 6, 7, 8, 9, 10, 11, 12,
	13, 14, 15, 16, -1, 17, 18, 19, 20, 21,
	22, 23, 24, -1, -1, 27, 28, 17, 18, 19,
	20, 21, 22, 23, 24, -1, -1, 27, 28, 17,
	18, 19, 20, 21, 22, 23, 24, -1, -1, 27,
	28, 17, 18, 19, 20, 21, 22, 23, 24, 17,
	18, 27, -1, 21, 22, 23, 24, 25, 17, 18,
	-1, -1, 21, 22, 23, 24
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
	0, 17, 18, 19, 20, 21, 22, 23, 24, 27,
	31, 32, 33, 34, 22, 33, 33, 24, 24, 24,
	27, 33, 32, 0, 34, 3, 4, 5, 6, 7,
	8, 9, 10, 11, 12, 13, 14, 15, 16, 29,
	24, 33, 33, 25, 33, 32, 25, 28, 33, 33,
	33, 33, 33, 33, 33, 33, 33, 33, 33, 33,
	33, 33, 33, 25, 25, 25, 26, 28, 25, 29,
	29, 27, 33, 32, 25, 28
};

#if !defined (YYSIZE_T) && defined (__SIZE_TYPE__)
#define YYSIZE_T __SIZE_TYPE__
#endif
#if !defined (YYSIZE_T) && defined (size_t)
#define YYSIZE_T size_t
#endif
#if !defined (YYSIZE_T)
#if defined (__STDC__) || defined (__cplusplus)
#include <stddef.h>   /* INFRINGES ON USER NAME SPACE */
#define YYSIZE_T size_t
#endif
#endif
#if !defined (YYSIZE_T)
#define YYSIZE_T unsigned int
#endif

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL          goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
	do                                                              \
		if (yychar == YYEMPTY && yylen == 1)                          \
		{                                                           \
			yychar = (Token);                                         \
			yylval = (Value);                                         \
			yytoken = YYTRANSLATE(yychar);                           \
			YYPOPSTACK;                                               \
			goto yybackup;                                            \
		}                                                           \
		else                                                          \
		{                                                           \
			yyerror("syntax error: cannot back up"); \
			YYERROR;                                                  \
		}                                                           \
	while (0)

#define YYTERROR        1
#define YYERRCODE       256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
#define YYLLOC_DEFAULT(Current, Rhs, N)         \
	Current.first_line = Rhs[1].first_line;      \
	Current.first_column = Rhs[1].first_column;    \
	Current.last_line = Rhs[N].last_line;       \
	Current.last_column = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
#define YYLEX yylex(YYLEX_PARAM)
#else
#define YYLEX yylex()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

#ifndef YYFPRINTF
#include <stdio.h>   /* INFRINGES ON USER NAME SPACE */
#define YYFPRINTF fprintf
#endif

#define YYDPRINTF(Args)                        \
	do {                                            \
		if (yydebug)                                  \
			YYFPRINTF Args;                             \
	} while (0)

#define YYDSYMPRINT(Args)                      \
	do {                                            \
		if (yydebug)                                  \
			yysymprint Args;                            \
	} while (0)

#define YYDSYMPRINTF(Title, Token, Value, Location)            \
	do {                                                            \
		if (yydebug)                                                  \
		{                                                           \
			YYFPRINTF(stderr, "%s ", Title);                         \
			yysymprint(stderr,                                       \
				Token, Value);        \
			YYFPRINTF(stderr, "\n");                                 \
		}                                                           \
	} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
   `------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print(short *bottom, short *top)
#else
static void
yy_stack_print(bottom, top)
short *bottom;
short *top;
#endif
{
	YYFPRINTF(stderr, "Stack now");
	for (/* Nothing. */; bottom <= top; ++bottom)
		YYFPRINTF(stderr, " %d", *bottom);
	YYFPRINTF(stderr, "\n");
}

#define YY_STACK_PRINT(Bottom, Top)                            \
	do {                                                            \
		if (yydebug)                                                  \
			yy_stack_print((Bottom), (Top));                           \
	} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
   `------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print(int yyrule)
#else
static void
yy_reduce_print(yyrule)
int yyrule;
#endif
{
	int yyi;
	unsigned int yylineno = yyrline[yyrule];
	YYFPRINTF(stderr, "Reducing stack by rule %d (line %u), ",
		yyrule - 1, yylineno);
	/* Print the symbols being reduced, and their result.  */
	for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
		YYFPRINTF(stderr, "%s ", yytname [yyrhs[yyi]]);
	YYFPRINTF(stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

#define YY_REDUCE_PRINT(Rule)          \
	do {                                    \
		if (yydebug)                          \
			yy_reduce_print(Rule);             \
	} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
#define YYDPRINTF(Args)
#define YYDSYMPRINT(Args)
#define YYDSYMPRINTF(Title, Token, Value, Location)
#define YY_STACK_PRINT(Bottom, Top)
#define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
#define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

#ifndef yystrlen
#if defined (__GLIBC__) && defined (_STRING_H)
#define yystrlen strlen
#else
/* Return the length of YYSTR.  */
static YYSIZE_T
#if defined (__STDC__) || defined (__cplusplus)
yystrlen(const char *yystr)
#else
yystrlen(yystr)
const char *yystr;
#endif
{
	register const char *yys = yystr;

	while (*yys++ != '\0')
		continue;

	return yys - yystr - 1;
}
#endif
#endif

#ifndef yystpcpy
#if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#define yystpcpy stpcpy
#else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#if defined (__STDC__) || defined (__cplusplus)
yystpcpy(char *yydest, const char *yysrc)
#else
yystpcpy(yydest, yysrc)
char *yydest;
const char *yysrc;
#endif
{
	register char *yyd = yydest;
	register const char *yys = yysrc;

	while ((*yyd++ = *yys++) != '\0')
		continue;

	return yyd - 1;
}
#endif
#endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
   `--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint(FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint(yyoutput, yytype, yyvaluep)
FILE * yyoutput;
int yytype;
YYSTYPE *yyvaluep;
#endif
{
	/* Pacify ``unused variable'' warnings.  */
	(void)yyvaluep;

	if (yytype < YYNTOKENS) {
		YYFPRINTF(yyoutput, "token %s (", yytname[yytype]);
#ifdef YYPRINT
		YYPRINT(yyoutput, yytoknum[yytype], *yyvaluep);
#endif
	} else
		YYFPRINTF(yyoutput, "nterm %s (", yytname[yytype]);

	switch (yytype) {
	default:
		break;
	}
	YYFPRINTF(yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
   `-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct(int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct(yytype, yyvaluep)
int yytype;
YYSTYPE *yyvaluep;
#endif
{
	/* Pacify ``unused variable'' warnings.  */
	(void)yyvaluep;

	switch (yytype) {

	default:
		break;
	}
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
#if defined (__STDC__) || defined (__cplusplus)
int yyparse(void *YYPARSE_PARAM);
#else
int yyparse();
#endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse(void);
#else
int yyparse();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
   `----------*/

#ifdef YYPARSE_PARAM
#if defined (__STDC__) || defined (__cplusplus)
int yyparse(void *YYPARSE_PARAM)
#else
int yyparse(YYPARSE_PARAM)
void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse(void)
#else
int
yyparse()

#endif
#endif
{

	register int yystate;
	register int yyn;
	int yyresult;
	/* Number of tokens to shift before error messages enabled.  */
	int yyerrstatus;
	/* Lookahead token as an internal (translated) token number.  */
	int yytoken = 0;

	/* Three stacks and their tools:
	   `yyss': related to states,
	   `yyvs': related to semantic values,
	   `yyls': related to locations.

	   Refer to the stacks thru separate pointers, to allow yyoverflow
	   to reallocate them elsewhere.  */

	/* The state stack.  */
	short yyssa[YYINITDEPTH];
	short *yyss = yyssa;
	register short *yyssp;

	/* The semantic value stack.  */
	YYSTYPE yyvsa[YYINITDEPTH];
	YYSTYPE *yyvs = yyvsa;
	register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

	YYSIZE_T yystacksize = YYINITDEPTH;

	/* The variables used to return semantic value and location from the
	   action routines.  */
	YYSTYPE yyval;


	/* When reducing, the number of symbols on the RHS of the reduced
	   rule.  */
	int yylen;

	YYDPRINTF((stderr, "Starting parse\n"));

	yystate = 0;
	yyerrstatus = 0;
	yynerrs = 0;
	yychar = YYEMPTY;       /* Cause a token to be read.  */

	/* Initialize stack pointers.
	   Waste one element of value and location stack
	   so that they stay on the same level as the state stack.
	   The wasted elements are never initialized.  */

	yyssp = yyss;
	yyvsp = yyvs;

	goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
   `------------------------------------------------------------*/
yynewstate:
	/* In all cases, when you get here, the value and location stacks
	   have just been pushed. so pushing a state here evens the stacks.
	 */
	yyssp++;

yysetstate:
	*yyssp = yystate;

	if (yyss + yystacksize - 1 <= yyssp) {
		/* Get the current used size of the three stacks, in elements.  */
		YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
		{
			/* Give user a chance to reallocate the stack. Use copies of
			   these so that the &'s don't force the real ones into
			   memory.  */
			YYSTYPE *yyvs1 = yyvs;
			short *yyss1 = yyss;


			/* Each stack pointer address is followed by the size of the
			   data in use in that stack, in bytes.  This used to be a
			   conditional around just the two extra args, but that might
			   be undefined if yyoverflow is a macro.  */
			yyoverflow("parser stack overflow",
				&yyss1, yysize * sizeof(*yyssp),
				&yyvs1, yysize * sizeof(*yyvsp),

				&yystacksize);

			yyss = yyss1;
			yyvs = yyvs1;
		}
#else /* no yyoverflow */
#ifndef YYSTACK_RELOCATE
		goto yyoverflowlab;
#else
		/* Extend the stack our own way.  */
		if (YYMAXDEPTH <= yystacksize)
			goto yyoverflowlab;
		yystacksize *= 2;
		if (YYMAXDEPTH < yystacksize)
			yystacksize = YYMAXDEPTH;

		{
			short *yyss1 = yyss;
			union yyalloc *yyptr =
				(union yyalloc *)YYSTACK_ALLOC(YYSTACK_BYTES(yystacksize));
			if (!yyptr)
				goto yyoverflowlab;
			YYSTACK_RELOCATE(yyss);
			YYSTACK_RELOCATE(yyvs);

#undef YYSTACK_RELOCATE
			if (yyss1 != yyssa)
				YYSTACK_FREE(yyss1);
		}
#endif
#endif /* no yyoverflow */

		yyssp = yyss + yysize - 1;
		yyvsp = yyvs + yysize - 1;


		YYDPRINTF((stderr, "Stack size increased to %lu\n",
			(unsigned long int)yystacksize));

		if (yyss + yystacksize - 1 <= yyssp)
			YYABORT;
	}

	YYDPRINTF((stderr, "Entering state %d\n", yystate));

	goto yybackup;

/*-----------.
| yybackup.  |
   `-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

	/* First try to decide what to do without reference to lookahead token.  */

	yyn = yypact[yystate];
	if (yyn == YYPACT_NINF)
		goto yydefault;

	/* Not known => get a lookahead token if don't already have one.  */

	/* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
	if (yychar == YYEMPTY) {
		YYDPRINTF((stderr, "Reading a token: "));
		yychar = YYLEX;
	}

	if (yychar <= YYEOF) {
		yychar = yytoken = YYEOF;
		YYDPRINTF((stderr, "Now at end of input.\n"));
	} else {
		yytoken = YYTRANSLATE(yychar);
		YYDSYMPRINTF("Next token is", yytoken, &yylval, &yylloc);
	}

	/* If the proper action on seeing token YYTOKEN is to reduce or to
	   detect an error, take that action.  */
	yyn += yytoken;
	if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
		goto yydefault;
	yyn = yytable[yyn];
	if (yyn <= 0) {
		if (yyn == 0 || yyn == YYTABLE_NINF)
			goto yyerrlab;
		yyn = -yyn;
		goto yyreduce;
	}

	if (yyn == YYFINAL)
		YYACCEPT;

	/* Shift the lookahead token.  */
	YYDPRINTF((stderr, "Shifting token %s, ", yytname[yytoken]));

	/* Discard the token being shifted unless it is eof.  */
	if (yychar != YYEOF)
		yychar = YYEMPTY;

	*++yyvsp = yylval;


	/* Count tokens shifted since error; after three, turn off error
	   status.  */
	if (yyerrstatus)
		yyerrstatus--;

	yystate = yyn;
	goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
   `-----------------------------------------------------------*/
yydefault:
	yyn = yydefact[yystate];
	if (yyn == 0)
		goto yyerrlab;
	goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
   `-----------------------------*/
yyreduce:
	/* yyn is the number of a rule to reduce with.  */
	yylen = yyr2[yyn];

	/* If YYLEN is nonzero, implement the default value of the action:
	   `$$ = $1'.

	   Otherwise, the following line sets YYVAL to garbage.
	   This behavior is undocumented and Bison
	   users should not rely upon it.  Assigning to YYVAL
	   unconditionally makes the parser a bit smaller, and it avoids a
	   GCC warning that YYVAL may be used uninitialized.  */
	yyval = yyvsp[1 - yylen];


	YY_REDUCE_PRINT(yyn);
	switch (yyn) {
	case 2:

	{
		script_result = yyvsp[0].cmd;
		YYACCEPT;
		;
	}
	break;

	case 3:

	{
		yyval.cmd = script_cmd_make_op2cc(yyvsp[-1].cmd, yyvsp[0].cmd);
		if (!yyval.cmd)
			YYERROR;
		;
	}
	break;

	case 4:

	{
		yyval.cmd = yyvsp[0].cmd;
		;
	}
	break;

	case 5:

	{
		yyval.exp = script_exp_make_op1v(SCRIPT_EXP_VALUE, yyvsp[0].val);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 6:

	{
		yyval.exp = script_exp_make_op1s(SCRIPT_EXP_VARIABLE, yyvsp[0].str);
		free((char*)yyvsp[0].str);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 7:

	{
		yyval.exp = script_exp_make_op1t(SCRIPT_EXP_TEXT, yyvsp[0].text);
		free((char*)yyvsp[0].text);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 8:

	{
		yyval.exp = yyvsp[-1].exp;
		;
	}
	break;

	case 9:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_ADD, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 10:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_SUB, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 11:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_AND, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 12:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_OR, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 13:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_XOR, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 14:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_L, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 15:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_G, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 16:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_E, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 17:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_LE, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 18:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_GE, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 19:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_SL, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 20:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_SR, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 21:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_LAND, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 22:

	{
		yyval.exp = script_exp_make_op2ee(SCRIPT_EXP_LOR, yyvsp[-2].exp, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 23:

	{
		yyval.exp = script_exp_make_op1e(SCRIPT_EXP_LNOT, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 24:

	{
		yyval.exp = script_exp_make_op1e(SCRIPT_EXP_NOT, yyvsp[0].exp);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 25:

	{
		yyval.exp = script_exp_make_op1f(SCRIPT_EXP_F0, yyvsp[-2].str);
		free((char*)yyvsp[-2].str);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 26:

	{
		yyval.exp = script_exp_make_op2fe(SCRIPT_EXP_F1, yyvsp[-3].str, yyvsp[-1].exp);
		free((char*)yyvsp[-3].str);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 27:

	{
		yyval.exp = script_exp_make_op3fee(SCRIPT_EXP_F2, yyvsp[-5].str, yyvsp[-3].exp, yyvsp[-1].exp);
		free((char*)yyvsp[-5].str);
		if (!yyval.exp) YYERROR;
		;
	}
	break;

	case 28:

	{
		yyval.cmd = script_cmd_make_op2sc("inner", yyvsp[-1].cmd);
		if (!yyval.cmd) YYERROR;
		;
	}
	break;

	case 29:

	{
		yyval.cmd = script_cmd_make_op3sec(yyvsp[-6].str, yyvsp[-4].exp, yyvsp[-1].cmd);
		free((char*)yyvsp[-6].str);
		if (!yyval.cmd) YYERROR;
		;
	}
	break;

	case 30:

	{
		yyval.cmd = script_cmd_make_op2sc(yyvsp[-3].str, yyvsp[-1].cmd);
		free((char*)yyvsp[-3].str);
		if (!yyval.cmd) YYERROR;
		;
	}
	break;

	case 31:

	{
		yyval.cmd = script_cmd_make_op2se("wait", yyvsp[-2].exp);
		if (!yyval.cmd) YYERROR;
		;
	}
	break;

	case 32:

	{
		yyval.cmd = script_cmd_make_op2se("delay", yyvsp[-2].exp);
		if (!yyval.cmd) YYERROR;
		;
	}
	break;

	case 33:

	{
		yyval.cmd = script_cmd_make_op2se("evaluate", yyvsp[-1].exp);
		if (!yyval.cmd) YYERROR;
		;
	}
	break;


	}

/* Line 991 of yacc.c.  */


	yyvsp -= yylen;
	yyssp -= yylen;


	YY_STACK_PRINT(yyss, yyssp);

	*++yyvsp = yyval;


	/* Now `shift' the result of the reduction.  Determine what state
	   that goes to, based on the state we popped back to and the rule
	   number reduced by.  */

	yyn = yyr1[yyn];

	yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
	if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
		yystate = yytable[yystate];
	else
		yystate = yydefgoto[yyn - YYNTOKENS];

	goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
   `------------------------------------*/
yyerrlab:
	/* If not already recovering from an error, report this error.  */
	if (!yyerrstatus) {
		++yynerrs;
#if YYERROR_VERBOSE
		yyn = yypact[yystate];

		if (YYPACT_NINF < yyn && yyn < YYLAST) {
			YYSIZE_T yysize = 0;
			int yytype = YYTRANSLATE(yychar);
			char *yymsg;
			int yyx, yycount;

			yycount = 0;
			/* Start YYX at -YYN if negative to avoid negative indexes in
			   YYCHECK.  */
			for (yyx = yyn < 0 ? -yyn : 0;
				yyx < (int)(sizeof(yytname) / sizeof(char *)); yyx++)
				if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
					yysize += yystrlen(yytname[yyx]) + 15, yycount++;
			yysize += yystrlen("syntax error, unexpected ") + 1;
			yysize += yystrlen(yytname[yytype]);
			yymsg = (char*)YYSTACK_ALLOC(yysize);
			if (yymsg != 0) {
				char *yyp = yystpcpy(yymsg, "syntax error, unexpected ");
				yyp = yystpcpy(yyp, yytname[yytype]);

				if (yycount < 5) {
					yycount = 0;
					for (yyx = yyn < 0 ? -yyn : 0;
						yyx < (int)(sizeof(yytname) / sizeof(char *));
						yyx++)
						if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR) {
							const char *yyq = !yycount ? ", expecting " : " or ";
							yyp = yystpcpy(yyp, yyq);
							yyp = yystpcpy(yyp, yytname[yyx]);
							yycount++;
						}
				}
				yyerror(yymsg);
				YYSTACK_FREE(yymsg);
			} else
				yyerror("syntax error; also virtual memory exhausted");
		} else
#endif /* YYERROR_VERBOSE */
		yyerror("syntax error");
	}



	if (yyerrstatus == 3) {
		/* If just tried and failed to reuse lookahead token after an
		   error, discard it.  */

		/* Return failure if at end of input.  */
		if (yychar == YYEOF) {
			/* Pop the error token.  */
			YYPOPSTACK;
			/* Pop the rest of the stack.  */
			while (yyss < yyssp) {
				YYDSYMPRINTF("Error: popping", yystos[*yyssp], yyvsp, yylsp);
				yydestruct(yystos[*yyssp], yyvsp);
				YYPOPSTACK;
			}
			YYABORT;
		}

		YYDSYMPRINTF("Error: discarding", yytoken, &yylval, &yylloc);
		yydestruct(yytoken, &yylval);
		yychar = YYEMPTY;

	}

	/* Else will try to reuse lookahead token after shifting the error
	   token.  */
	goto yyerrlab2;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
   `----------------------------------------------------*/
yyerrlab1:

	/* Suppress GCC warning that yyerrlab1 is unused when no action
	   invokes YYERROR.  */
#if defined (__GNUC_MINOR__) && 2093 <= (__GNUC__ * 1000 + __GNUC_MINOR__)
	__attribute__ ((__unused__))
#endif


	goto yyerrlab2;


/*---------------------------------------------------------------.
| yyerrlab2 -- pop states until the error token can be shifted.  |
   `---------------------------------------------------------------*/
yyerrlab2:
	yyerrstatus = 3; /* Each real token shifted decrements this.  */

	for (;; ) {
		yyn = yypact[yystate];
		if (yyn != YYPACT_NINF) {
			yyn += YYTERROR;
			if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR) {
				yyn = yytable[yyn];
				if (0 < yyn)
					break;
			}
		}

		/* Pop the current state because it cannot handle the error token.  */
		if (yyssp == yyss)
			YYABORT;

		YYDSYMPRINTF("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		yydestruct(yystos[yystate], yyvsp);
		yyvsp--;
		yystate = *--yyssp;

		YY_STACK_PRINT(yyss, yyssp);
	}

	if (yyn == YYFINAL)
		YYACCEPT;

	YYDPRINTF((stderr, "Shifting error token, "));

	*++yyvsp = yylval;


	yystate = yyn;
	goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
   `-------------------------------------*/
yyacceptlab:
	yyresult = 0;
	goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
   `-----------------------------------*/
yyabortlab:
	yyresult = 1;
	goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
   `----------------------------------------------*/
yyoverflowlab:
	yyerror("parser stack overflow");
	yyresult = 2;
	/* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
	if (yyss != yyssa)
		YYSTACK_FREE(yyss);
#endif
	return yyresult;
}





const char* script_input_begin;
const char* script_input_end;

int script_input(char* buf, int max_size)
{
	(void)max_size;
	if (script_input_begin == script_input_end) {
		return 0;
	} else {
		*buf = *script_input_begin++;
		return 1;
	}
}

struct script_cmd* script_parse(const char* text)
{
	int r;
	script_input_begin = text;
	script_input_end = script_input_begin + strlen(script_input_begin);
	r = yyparse();
	if (r != 0)
		return 0;

	r = yylex();
	if (r != 0) {
		if (r == STRING) {
			char buffer[256];
			snprintf(buffer, sizeof(buffer), "Unexpected token '%s'", yylval.str);
			yyerror(buffer);
		} else if (r < 255) {
			char buffer[256];
			snprintf(buffer, sizeof(buffer), "Unexpected token '%c'", (char)r);
			yyerror(buffer);
		} else {
			yyerror("Unexpected token");
		}
		return 0;
	}

	return script_result;
}

